﻿using System;
using System.Data;
using System.Configuration;
using System.Linq;
using System.Web;
using System.Web.Security;
using System.Web.UI;
using System.Web.UI.HtmlControls;
using System.Web.UI.WebControls;
using System.Web.UI.WebControls.WebParts;
using System.Xml.Linq;

using System.Threading;
using System.Windows.Forms;

namespace ASP.NET_WebBrowser
{
    public class IEBrowser: System.Windows.Forms.ApplicationContext
    {
        WebBrowser ieBrowser;
        Form form;
        Thread thrd;

        public IEBrowser()
        {
            thrd = new Thread(new ThreadStart(
                delegate
                {
                    Init();
                    System.Windows.Forms.Application.Run(this);
                }));
            // set thread to STA state before starting
            thrd.SetApartmentState(ApartmentState.STA);
            thrd.Start();
        }

        private void Init()
        {
            // create a WebBrowser control
            ieBrowser = new WebBrowser();

            // WebBrowser EnventHandler
            //ieBrowser.DocumentCompleted += new WebBrowserDocumentCompletedEventHandler(IEBrowser_DocumentCompleted);
            //ieBrowser.Navigating += new WebBrowserNavigatingEventHandler(IEBrowser_Navigating);

            form = new System.Windows.Forms.Form();
            ieBrowser.Dock = System.Windows.Forms.DockStyle.Fill;
            form.Controls.Add(ieBrowser);
            form.Visible = true;

            ieBrowser.Navigate("http://naver.com");
        }

        protected override void Dispose(bool disposing)
        {
            if (thrd != null)
            {
                thrd.Abort();
                thrd = null;
                return;
            }

            System.Runtime.InteropServices.Marshal.Release(ieBrowser.Handle);
            ieBrowser.Dispose();
            if (form != null) form.Dispose();
            base.Dispose(disposing);
        }

        // 인터넷의 로딩이 완료되면 창이 닫힘.
        void IEBrowser_DocumentCompleted(object sender, WebBrowserDocumentCompletedEventArgs e)
        {
            this.Dispose(true);
        }
    }

    
}
